% Gradient Reconstruction

close all,clear all, clc
%rand('state',2)

N=32;   % total number of samples
M=8;    % number of missing samples
t = 0:1/N:1-1/N;
n = 0:N-1;

% signal x(n) with sparsity 6
x = 3*sin(2*pi*10*t)+2*cos(2*pi*30*t)+0.5*sin(2*pi*23*t);
figure(1),subplot(311),
h=stem(n,x,'ko'); axis([0 N+1 -6 6]);grid on
title('Original signal \itx(n)')

% Random missing sample positions
p = randperm(N);
y = x;
y(p(1:M)) = 0;
y0=y;               % initial y

subplot(312),
h=stem(n(p(M+1:end)),y(p(M+1:end)),'ko');hold on,
h2=stem(n(p(1:M)),y(p(1:M)),'xr','filled');hold off
axis([0 N+1 -6 6]),grid on
title('Available samples')

delta=max(abs(y));
Precision=100; % Precision in dB
yr=GradRec(y,p(1:M),{@fft,Precision},delta,60);

Obtained_precision=20*log10(max(abs(yr-x))/max(abs(x)))

subplot(313),
h3=stem(n(p(1:M)),yr(p(1:M)));
set(h3,'color',0.85*[1,1,1],'marker','none','linewidth',2),hold on
h=stem(n(p(M+1:end)),yr(p(M+1:end)),'ko');
h2=stem(n(p(1:M)),yr(p(1:M)),'r');hold off
axis([0 N+1 -6 6]),
grid on
title(['Reconstructed signal '])

